Subject: Re: [IPsec] New Version Notification for draft-tjhai-ipsecme-hybrid-qske-ikev2-03.txt

From: "Valery Smyslov" <[email-masked]>
Date: Tue, 9 Apr 2019 10:19:47 +0300

Hi Tobias,

thank you for very comprehensive side meeting report. Sorry for late reply, see my comments inline.

From: IPsec [mailto:[email-masked]] On Behalf Of Tobias Heider
Sent: Wednesday, March 27, 2019 8:30 PM
To: IPsecME WG
Cc: [email-masked]; [email-masked]
Subject: Re: [IPsec] New Version Notification for draft-tjhai-ipsecme-hybrid-qske-ikev2-03.txt

Hi,

we had a side meeting today where some of us shared our experiences implementing this
draft and we had the chance to discuss the future of this draft with the authors.
Here's what we have talked about and our results:

#1 Nonces in IKE_INTERMEDIATE and CHILD_SA exchanges:

The current draft proposes to send a pair of new nonces in every subsequent IKE_INTERMEDIATE exchange.
We agreed that none of us sees any obvious security problems with only using the nonces exchanged in 
IKE_SA_INIT, but we should try to get this confirmed by cryptologists (maybe CFRG can help).

          Since it mostly concerns security, I’d rather let cryptographers to decide.

#2 Using a single IKE_INTERMEDIATE to transport all additional keys

One single big IKE_INTERMEDIATE message that transports all additional key exchanges would be enough to
allow big keys to be fragmented. The main problem of this approach is that fragmentation handles lost 
fragments by resending all fragments. There is no way of requesting retransmission of a single fragment.
This may turn out to be a problem, which is why each new key is sent in a separate IKE_INTERMEDIATE.

          True, that’s why we use an approach when one IKE_INTERMEDIATE conveys one QSKE.

          I don’t think it makes implementations substantially more complex – 

          if you can do one IKE_INTERMEDIATE, it’s not difficult to do more than one.

          What about delay, it’s a complex matter – whether sending large fragmented

          message with one round trip is better that sending several smaller messages 

          with several round trips.

Another solution might be to change fragmentation to allow retransmission of single fragments.

          Actually, it’s not easy to achieve and would have required to change the core IKE logic.

          The problem is on the return path – how the initiator would request resending

          a single fragment if it is lost in the response? This would have required to 

          significantly complicate IKE’s core, and I don’t think we are in a position to do it.

#3 Using a reserved field to avoid 7 new transform types

It was discussed whether it makes sense to use a reserved field in the transform substructure header
to combine transforms of the same transform type (e.g. Diffie-Hellman group) with logical AND instead of OR.
We agreed that the current solution is less work to implement and using the reserved field offers no
functional benefit.

          Yes, we reused existing functionality.

#4 Big Keys (e.G. Classic McEliece)

In general there was consensus that we should find a way to enable the use of McEliece keys.
The problem is that McEliece keys are >1MB in size and thus can not fit into the KE payload
(which has a 16 bit size field).

The solution we came up with is fragmenting a single key over several KE payloads which are transmitted
in a single IKE_INTERMEDIATE message that can be fragmented over several udp datagrams using
IKEv2 fragmentation:

HDR, SK {KE(Fragment 1), KE(Fragment 2), KE(Fragment 3)} -->
       <-- HDR, SK {KE(Fragment 1), KE(Fragment 2), KE(Fragment 3)}

This approach is only limited by the size field of the IKEv2 header, which is 32 bit.

          To be accurate, there is another limitation for this approach.

          IKE fragmentation allows to have up to 2^16 fragments, so depending

          on the fragment size there is a limit on the size of IKE message 

          that can be fragmented. As far as I know many implementations

          use fixed fragment size of 576 bytes. If we subtract from this 

          value the size of IP, UDP, IKE Header, IKE trailer etc., it’s about 

          ~500 bytes of useful data, so the original KE must be less than

          ~32MB. I hope it’s enough for any sensible key exchange method,

          including McEliece. For IPv6 fragment size is usually 1280 bytes,

          so this limitation would be relaxed a bit in case of IPv6.

#5 Rekeying and CREATE_CHILD_SA

Nonces should be handled as said in #1.
The draft does not yet specify how the new SKEYSEED is generated.
We agreed that the best way would be to do this in a single prf (different than in the INTERMEDIATE
exchanges which are "rekeying" incrementally), e.G. :

    SKEYSEED = prf(SK_d(old), KE1result | KE2result | ... | Ni |Nr)

          I’d rather change it as follows:

          SKEYSEED = prf(SK_d(old), KE1result | Ni  |Nr | KE2result | KE3result | ...)

          This would allow not to keep nonces from CREATE_CHILD_SA until all the additional exchanges are completed

          and instead use the running prf state. 

          In case each additional exchange uses its own nonce (as currently specified)  it would be:

          SKEYSEED = prf(SK_d(old), KE1result | N1i  |N1r | KE2result | N2i  |N2r | KE3result | N3i  |N3r |...)

          This formulas can also be used in case of creating/rekeying IPsec SA:

          KEYMAT = prf+(SK_d, KE1result | Ni  |Nr | KE2result | KE3result | ...)

          or

          KEYMAT = prf+(SK_d, KE1result | N1i  |N1r | KE2result | N2i  |N2r | KE3result | N3i  |N3r |...)

The use of INFORMATIONAL exchange for the additional key exchanges was criticized.
Several alternative designs were discussed, here's the most important ones:

Design 1: Sending all in a single exchange:

HDR(CREATE_CHILD_SA), SK {SA, Ni, KEi, KEi2, KEi3, KEi4} -->
    <-- HDR(CREATE_CHILD_SA), SK {SA, Nr, KEr, KEr2, KEr3, KEr4}

Problems include that the initiator might generate keys that are then not accepted by the responder.
Also the message would probably be very big, so the same problems as in #2 apply here.
It was discussed what happens if the responder does not accept the proposal.
As in normal IKEv2 the INVALID_KE notify can be sent by the responder and that CREATE_CHILD_SA
has to be redone with the new knowledge of what the responder supports.

          True.

Design 2: Single additional INFORMATIONAL

HDR(CREATE_CHILD_SA), SK {SA, Ni, KEi} -->
    <-- HDR(CREATE_CHILD_SA), SK {SA, Nr, KEr, N(ADDITIONAL_KE)(link1)}

HDR(INFORMATIONAL), SK {KEi2, KEi3, KEi4, N(ADDITIONAL_KE)(link1)} -->
    <-- HDR(INFORMATIONAL), SK {KEr2, KEr3, KEr4}

Implementers might have problems with the complexity of using the (link1) cookie
values as well as with the use of INFORMATIONAL for yet another thing.

          I think that if implementation can do one additional INFORMATIONAL,

          it’s not difficult to do several of them. So I see no substantial

          advantages of limiting the number of trailer exchanges to 

          exactly one.

          Regards,

          Valery.

Feel free to correct us or comment if we made a mistake or missed something important!
Thanks to everyone for joining the conversation!

Regards,
Tobias and Stefan